PDA

Bekijk de volledige versie : Perl?



Barefoot
02-03-2007, 01:18
Hi,

I would love to have a "real" perl running on the box. Via ipkg there is only a microperl offered, which is not sufficient for my needs.

Has anyone done it before? I don't think I am capable of compiling my own perl there...

regards,

anton610
02-03-2007, 16:36
Look at: http://ipkg.nslu2-linux.org/feeds/optware/oleg/cross/stable/

and enjoy perl :D

Barefoot
02-03-2007, 22:19
I am afraid this does not work... whenever I want to start a binary provided by this package I get

[admin@my bin]$ perl
-sh: perl: not found

Are you sure those are compiled for the right platform? I don't like the "nslu2" in the URL...

wengi
03-03-2007, 07:41
This works on WLxxxx.

And now the big BUT:

You need to update to newest ipkg AND newest uclib.
You will have to reinstall the most packages after uclib update.


wget http://ipkg.nslu2-linux.org/feeds/optware/oleg/cross/stable/ipkg-opt_0.99.163-9_mipsel.ipk
ipkg.sh install ipkg-opt_0.99.163-9_mipsel.ipk
wget http://ipkg.nslu2-linux.org/feeds/optware/oleg/cross/stable/uclibc-opt_0.9.28-12_mipsel.ipk
ipkg.sh install uclibc-opt_0.9.28-12_mipsel.ipk
ipkg update

Barefoot
03-03-2007, 15:13
That works, thanks a lot.

But now it's apache that does not work... well, let's see :-)

Barefoot
18-03-2007, 11:55
This works on WLxxxx.

And now the big BUT:

You need to update to newest ipkg AND newest uclib.
You will have to reinstall the most packages after uclib update.



Perl is running fine, but I am absolutely unable to use Compress:Zlib. Perl claims to be not compiled for module support, but that's nonsense - right?

VirtualMan
30-03-2007, 17:52
I am sorry, but my PERL tells me "can't load library 'libgdbm.so.3'" :(

[admin@(none) root]$ ipkg.sh install http://ipkg.nslu2-linux.org/feeds/optware/oleg/cross/stable/ipkg-opt_0.99.163-9_mipsel.ipk
Downloading http://ipkg.nslu2-linux.org/feeds/optware/oleg/cross/stable/ipkg-opt_0.99.163-9_mipsel.ipk ...
Connecting to ipkg.nslu2-linux.org[140.211.167.165]:80
ipkg-opt_0.99.163-9_ 100% |*****************************| 75887 00:00 ETA
Done.
ERROR: File not found: /opt/lib/ipkg/lists/wl500g
You probably want to run `ipkg update'
Unpacking ipkg-opt...Done.
Configuring ipkg-opt...Done.

[admin@(none) root]$ ipkg.sh install http://ipkg.nslu2-linux.org/feeds/optware/oleg/cross/stable/uclibc-opt_0.9.28-12_mipsel.ipk
Downloading http://ipkg.nslu2-linux.org/feeds/optware/oleg/cross/stable/uclibc-opt_0.9.28-12_mipsel.ipk ...
Connecting to ipkg.nslu2-linux.org[140.211.167.165]:80
uclibc-opt_0.9.28-12 100% |*****************************| 832 KB 00:00 ETA
Done.
ERROR: File not found: /opt/lib/ipkg/lists/wl500g
You probably want to run `ipkg update'
Unpacking uclibc-opt...Done.
Configuring uclibc-opt...Updating /opt/etc/ld.so.cache
Done.

[admin@(none) root]$ /opt/bin/ipkg update
Downloading http://ipkg.nslu2-linux.org/feeds/optware/oleg/cross/stable/Packages.gz
Inflating http://ipkg.nslu2-linux.org/feeds/optware/oleg/cross/stable/Packages.gz
Updated list of available packages in /opt/lib/ipkg/lists/optware
Successfully terminated.

[admin@(none) root]$ /opt/bin/ipkg install perl
Installing perl (5.8.8-14) to /opt/...
Downloading http://ipkg.nslu2-linux.org/feeds/optware/oleg/cross/stable/perl_5.8.8-14_mipsel.ipk
Installing libdb (4.2.52-3) to /opt/...
Downloading http://ipkg.nslu2-linux.org/feeds/optware/oleg/cross/stable/libdb_4.2.52-3_mipsel.ipk
Configuring libdb
Configuring perl
Successfully terminated.

[admin@(none) root]$ perl
perl: can't load library 'libgdbm.so.3'
Any ideas?
thx Vladimir

oleo
30-03-2007, 19:19
ipkg install gdbm, updated http://trac.nslu2-linux.org/optware/changeset/5851

VirtualMan
30-03-2007, 21:49
BINGO! Thanx!

birdman
03-04-2007, 22:15
I am sorry, but my PERL tells me "can't load library 'libgdbm.so.3'" :(Having made a similar update I get a similar problem with the perl-compress-zlib package.

Can't load module Compress::Zlib, dynamic loading not available in this perl.
(You may need to build a new perl executable which either supports
dynamic loading or has the Compress::Zlib module statically linked into it.)
at new_idcheck6 line 3
Compilation failed in require at new_idcheck6 line 3.Oddly(?) this package contains Zlib.so, while all other compiled Perl packages have *.a files for the loadable code.

oleo
04-04-2007, 14:05
Please try updated perl (-16). I have included dynamic loader with http://trac.nslu2-linux.org/optware/changeset/5887

birdman
04-04-2007, 21:23
Please try updated perl (-16). I have included dynamic loader with http://trac.nslu2-linux.org/optware/changeset/5887Thanks - I'd just noticed the update (after I'd used -15 to build my own perl with Compress::Zlib in as a static build) and was about to post a comment!

perl-compress-zlib now works OK

The standard modules are still statically linked though, which means you get them (the compiled code) all loaded into memory even if you don't use them.

oleo
04-04-2007, 23:24
suggest config change and I wiil include this if feasible

birdman
13-04-2007, 00:12
suggest config change and I wiil include this if feasibleI'll see what I can do. Not sure what options you used in the current config, though.

oleo
13-04-2007, 07:08
Here is the config http://trac.nslu2-linux.org/optware/browser/trunk/sources/perl/Cross/config.sh-mipsel-linux

birdman
17-04-2007, 20:46
suggest config change and I wiil include this if feasibleThe issue is that the extension list is in static_ext rather than in dynamic_ext. It's a result of (something like) this question when running Configure.

Looking for extensions...
A number of extensions are supplied with perl5. You may choose to
compile these extensions for dynamic loading (the default), compile
them into the perl5 executable (static loading), or not include
them at all. Answer "none" to include no extensions.
Note that DynaLoader is always built and need not be mentioned here.

What extensions do you wish to load dynamically?
[B ByteLoader Cwd DB_File Data/Dumper Devel/DProf Devel/PPPort
Devel/Peek Digest/MD5 Encode Fcntl File/Glob Filter/Util/Call
GDBM_File I18N/Langinfo IO IPC/SysV List/Util MIME/Base64 Opcode
POSIX PerlIO/encoding PerlIO/scalar PerlIO/via SDBM_File Socket
Storable Sys/Hostname Sys/Syslog Time/HiRes Unicode/Normalize
XS/APItest XS/Typemap attrs re threads threads/shared]
What extensions do you wish to load statically? [none]

If you could shift them to the dynamic list it would be nice.